/*
 * Copyright (c) 2010 David Galindo <nowheremanmail@gmail.com>
 */

#ifndef DETAIL_H
#define DETAIL_H

#include <QtGui>
#include <QDebug>
#include "DatabaseManager.h"
#include "CreateFieldDialog.h"
#include "ImageViewer.h"
#include "QLabelImage.h"
#include "CreatePasswordDialog.h"
class eWallet;


class DetailWindow: public QMainWindow, FieldsHelper
{
	Q_OBJECT

public:
	DetailWindow (Target * target, const QString & groupName, int istemplate, bool edit, eWallet *paTarget, QWidget *parent = 0);
	~DetailWindow ();
	
	void addField (TargetField * field);
	static void loadImage (QSettings & settings, QString q, QImage& res);

	void showN ();
	void hideN ();

private:
	int pos;
	int elType;
	eWallet * parent;
	
	QLabelImage * imageLabel;
	QLabelImage * imageBackLabel;
	Target * target;
	QWidget * centralWidget;
	QVBoxLayout * vboxlayout;
	QScrollArea * entryScrollArea;

	QLineEdit * nameLineEdit;
	QLineEdit * groupLineEdit;
	QComboBox * typeLineEdit;
	QList<QLineEdit*> labels;
	QList<QWidget*> values;

	QPointer <QMessageBox> messageBox;

	QImage * currentImage;
	QImage * currentImageBack;
	QImage * currentImageN;
	QImage * currentImageBackN;

	QString orgType;

	void showFields ();
	void changeFields (int);
	void _addField (TargetField * field);

	void closeEvent(QCloseEvent *event);
	bool edit;
	bool deleteFace;
	bool deleteBack;
	bool isNew;
	bool typeChanged;
	bool forceClose;

	QGridLayout * componentLayout;
	QPointer<CreateFieldDialog> createFieldDlg;
	QSignalMapper * signalMapper;
	QPointer<CreatePasswordDialog> createPasswordDlg;

public slots:
	void saveTarget();
	void _deleteTarget();
	void _editTarget();
	void _newTarget();

	void takePicture();
	void photoTake (QImage* image);


	void _newLikeTarget();
	void _duplicateTarget();

	void cardFace();
	void mirrorFace();
	void rotateFace();

	void orientationChanged (int);

	void deleteCardFace();
	void exportCardFace();
	void cardBack();	
	void mirrorBack();
	void rotateBack();
	void deleteCardBack();
	void exportCardBack();

	static void exportImage(QWidget * witdget, QImage * im, QString d, QString tit);

//	void seePicture ();
//	void seeBackPicture ();
//	void seeOtherPicture ();
//	void windowViewerDestroyed(QObject* obj);

//	void cardMenu(const QPoint & pos);
//	void labelMenu(const QPoint & pos);
	void cardFaceMenu(const QPoint & pos);
	void cardBackMenu(const QPoint & pos);
	void imageMenu(const QPoint & pos);
//	void contextMenuEvent (QContextMenuEvent * event);

	void emitCommitData (int);
	void clickPass (QWidget *);
	void passGen (QWidget *);
	void modifyFields ();

signals:
	void newTarget();
	void editTarget(Target * source);
	void newLikeTarget(Target * source);
	void duplicateTarget(Target * source);
public:
	//bool fieldsChanged;

	void forceclose ();

	QSettings settings;
};

class ButtonInfo: public QObjectUserData {
public:
	TargetField * field;

	ButtonInfo (TargetField * field) {
		this->field = field;
	}
};

class ButtonInfo2: public QObjectUserData {
public:
	QLineEdit * nameLineEdit;

	ButtonInfo2 (QLineEdit * nameLineEdit) {
		this->nameLineEdit = nameLineEdit;
	}
};
#endif // DETAIL_H
